unit uPluginPedidosCliente;

interface

uses
  uModuleController, uInterfaces, uHostManager, Menus, Classes, ActnList,
  ImgList, Controls, PngImageList, uPlugins_Intf;

type
  TPluginPedidosCliente = class(TModuleController, IMCPedidosCliente)
    actPedidosCliente: TAction;
    ExtraImages: TPngImageList;
    LargeImages: TPngImageList;
    MainMenu: TMainMenu;
    ModuleActionList: TActionList;
    SmallImages: TPngImageList;
    Ventas1: TMenuItem;
    PedidosaCliente1: TMenuItem;
    procedure actPedidosClienteExecute(Sender: TObject);
  public
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
    procedure VerPedidos(const ID_Cliente: Integer; const ANombreCliente : String = '');
  end;

implementation

{$R *.dfm}

uses
  Forms, Dialogs, SysUtils, cxControls,
  uPedidosClienteController, uBizPedidosCliente, uPedidosClienteViewRegister;

function GetModule : TModuleController;
begin
  Result := TPluginPedidosCliente.Create(NIL);
end;

exports
  GetModule name GET_MODULE_FUNC;

procedure TPluginPedidosCliente.actPedidosClienteExecute(Sender: TObject);
var
  APedidosClienteController : IPedidosClienteController;
  APedidosCliente : IBizPedidoCliente;

begin
  APedidosClienteController := TPedidosClienteController.Create;
  APedidosCliente := (APedidosClienteController.BuscarTodos as IBizPedidoCliente);
  APedidosClienteController.VerTodos(APedidosCliente);
end;

constructor TPluginPedidosCliente.Create(AOwner: TComponent);
begin
  inherited;
  ModuleName := MODULENAME_PEDIDOS_PROVEEDOR;
  uPedidosClienteViewRegister.RegisterViews;
end;

destructor TPluginPedidosCliente.Destroy;
begin
  uPedidosClienteViewRegister.UnregisterViews;
  inherited;
end;

procedure TPluginPedidosCliente.VerPedidos(const ID_Cliente: Integer;
  const ANombreCliente: String);
var
  APedidosController : IPedidosClienteController;
  APedidos : IBizPedidoCliente;
  AText : String;
begin
  AText := Format('Lista de pedidos del cliente %s', [ANombreCliente]);
  APedidosController := TPedidosClienteController.Create;
  try
    ShowHourglassCursor;
    try
      APedidos := APedidosController.BuscarTodos(ID_Cliente);
    finally
      HideHourglassCursor;
    end;
    APedidosController.VerTodos(APedidos, True, AText);
  finally
    APedidos := NIL;
    APedidosController := NIL;
  end;
end;


initialization
  RegisterModuleClass(TPluginPedidosCliente);

finalization
  UnRegisterModuleClass(TPluginPedidosCliente);

end.
